#include <windows.h>
#define _FAR_NO_NAMELESS_UNIONS
#include "plugin.hpp"
#include "goto.hpp"

static struct PluginStartupInfo Info;
static struct FarStandardFunctions FSF;
BOOL IsOldFar;

void InitDialogItems(const struct InitDialogItem *Init,struct FarDialogItem *Item,int ItemsNumber);
/*
 㭪 GetMsg 頥 ப ᮮ饭  몮 䠩.
   ன  Info.GetMsg  ᮪饭  :-)
*/
char *GetMsg(int MsgId)
{
  return(char *)Info.GetMsg(Info.ModuleNumber,MsgId);
}

/*
㭪 SetStartupInfo 뢠  ࠧ, । ᥬ
㣨 㭪ﬨ.  ।  ଠ,
室  쭥襩 ࠡ.
*/
void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *Info)
{
  ::Info=*Info;
    IsOldFar=TRUE;
  if(Info->StructSize >= sizeof(struct PluginStartupInfo))
  {
  ::FSF=*Info->FSF;
  ::Info.FSF=&::FSF;
    IsOldFar=FALSE;
  }
}

/*
㭪 GetPluginInfo 뢠  祭 ᭮
  (general) ଠ樨  
*/
void WINAPI _export GetPluginInfo(struct PluginInfo *pi)
{
  static char *PluginMenuStrings[1];

  if(!IsOldFar)
  {
  pi->StructSize=sizeof(struct PluginInfo);

  PluginMenuStrings[0]=GetMsg(MTitle);
  pi->PluginMenuStrings=PluginMenuStrings;
  pi->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
  }
}

/*
  㭪 OpenPlugin 뢠  ᮧ   .
*/
HANDLE WINAPI _export OpenPlugin(int OpenFrom,int item)
{
  	char *Dir;
	char histdir[]="Gotodir";
	char dir2[MAX_PATH];
	int ExitCode=-1;

  struct InitDialogItem InitItems []={
    DI_DOUBLEBOX,3,1,72,6,0,0,0,0,(char *)MTitle,				//0
    DI_TEXT,5,2,0,0,0,0,0,0,(char *)MTitleedit1,				//1
    DI_EDIT,5,3,70,0,	1,(DWORD)histdir,DIF_HISTORY,0,dir2,	//2
    DI_BUTTON,0,5,0,0,	0,0,DIF_CENTERGROUP,1,(char *)MOk,		//3
    DI_BUTTON,0,5,0,0,0,0,DIF_CENTERGROUP,0,(char *)MCancel,	//4
    DI_BUTTON,0,5,0,0,0,0,DIF_CENTERGROUP,0,(char *)MHelp		//5
  };
  struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];

  if(!IsOldFar){
	lstrcpy(dir2,"");
	InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
	do{
		ExitCode=Info.Dialog(Info.ModuleNumber,-1,-1,76,8,"Contents",DialogItems,sizeof(DialogItems)/sizeof(DialogItems[0]));
  		if (ExitCode==5) {
			Info.ShowHelp(Info.ModuleName,"Contents",0);
  		}
	}while(ExitCode==5);	//for help

  switch(ExitCode){
  case 2:
  case 3: {
	Dir=DialogItems[2].Data.Data;	FSF.Unquote(Dir);
    Info.Control(INVALID_HANDLE_VALUE,FCTL_SETPANELDIR,(void*)Dir);
	return &Info;
  }
  case -1: {
	return  INVALID_HANDLE_VALUE;
  }
  default :{
	return  INVALID_HANDLE_VALUE;
  }
  }//switch

  }//oldfar
  return  INVALID_HANDLE_VALUE;
}

void InitDialogItems(const struct InitDialogItem *Init,struct FarDialogItem *Item,int ItemsNumber)
{
  int I;
  struct FarDialogItem *PItem=Item;
  const struct InitDialogItem *PInit=Init;
  for (I=0;I<ItemsNumber;I++,PItem++,PInit++)
  {
    PItem->Type=PInit->Type;
    PItem->X1=PInit->X1;
    PItem->Y1=PInit->Y1;
    PItem->X2=PInit->X2;
    PItem->Y2=PInit->Y2;
    PItem->Focus=PInit->Focus;
    PItem->Param.Selected=PInit->Selected;
    PItem->Flags=PInit->Flags;
    PItem->DefaultButton=PInit->DefaultButton;
    strcpy(PItem->Data.Data,((unsigned int)PInit->Data<2000)?
           GetMsg((unsigned int)PInit->Data):PInit->Data);
  }
}

int WINAPI _export GetMinFarVersion(void)
{
  return(MAKEFARVERSION(1,70,1282));
}
